#!/usr/bin/perl -w

# script to remove sequences with a certain sequence ID from a fasta
# file. Adjusted from http://www.biostars.org/p/2822/
use strict;

if ($ARGV[0] eq ''){
    die "You need to provide two input files: 1) a fasta file, and 2) a text file of sequence IDs (one ID per line)\n";
}

if ($ARGV[1] eq ''){
    die "You need to provide two input files: 1) a fasta file, and 2) a text file of sequence IDs (one ID per line)\n";
}


my %ids  = (); # an empty hash
my $OUT = ">outfiltered.fasta";
my $REMAIN = ">remaining.fasta";

open(OUT, $OUT) or die "Can't open $OUT: \n"; # The outfiltered sequences will be stored in this file
open(REMAIN, $REMAIN) or die "Can't open $REMAIN: \n"; # The remaining sequences will be stored in this file



open(FILE, $ARGV[1]) or die "Can't open the text file with the IDs\n"; 
while(<FILE>) {
  chomp; # Removing end-of-line characters
  $ids{$_} += 1; # to every id value (key) a number (value) is assigned
}
close FILE;

local $/ = "\n>";  # read by FASTA record; $/ is the input record
		   # separator, here it is set to the beginning of a
		   # new fasta headline

open(FASTA, $ARGV[0]) or die "Can't open the FASTA file \n"; 
while (<FASTA>) {
     chomp;
     my $seq = $_;
     my ($id) = $seq =~ /^>*(\S+)/;  # parse ID as first word in FASTA header, \S matches anything but a white space
     $seq =~ s/>//; # Remove any > signs in the fasta sequence.
     if (exists($ids{$id})) { # If the ID is in the list do print it out to file 1
print OUT ">$seq\n";
     }
     else{print REMAIN ">$seq\n";} # If the ID is not in the list of sequences that shall be remove, then print it out to file 2
}
close FASTA;


close OUT;

close REMAIN;
